import numpy as np
import socket
from select import select
import servThread

#import os
#os.environ["PYTHONDONTWRITEBYTECODE"]="True"

BUFFER_SIZE = 32

#funkcija koja vraca true ako je resurs iskoristen, a false ako je proslo odredeno vrijeme
def resBusy(res,timeout):
	i,_,_ = select([res],[],[],timeout)
	return i

#funkcija koju server izvrsava dok je upaljen
def podaciSaMicrobita(server):
	server.socket.listen(1)
	print("Cekam konekciju 50 sekundi")
	uspjeh = resBusy(server.socket,50)

	if uspjeh:
		conn, addr = server.socket.accept()
		print("Konekcija s adrese: "+str(addr))

		#Ovo nam omogucuje da ugasimo server tako da stavimo server.thrRunning=False
		while server.thrRunning:
			uspjeh2 = resBusy(conn,1)

			if uspjeh2:
				data = conn.recv(BUFFER_SIZE)
				print(data)

		conn.close()
		
	else:
		print("Nema konekcije.")
		return


#IP adresa ovog racunala i port na kojem se vrsi komunikacija
TCP_IP = "192.168.137.197"
TCP_PORT = 5005

#Stvaramo instancu servThread-a i pokrecemo ga kao posebnu dretvu
server = servThread.servThread((TCP_IP,TCP_PORT),podaciSaMicrobita)
server.start()

#U glavnoj dretvi cekamo input za ugasiti server
inp=""
while inp!="quit":
	inp= raw_input("Upisi quit za ugasiti\n")

print("RIP server")

server.thrRunning=False
server.join()
